CARTCONVERT(1)

NAME
CartConvert -- convert geodetic coordinates to geocentric or local cartesian

SYNOPSIS
CartConvert [ -r ] [ -l lat0 lon0 h0 ] [ -e a f ] [ -w ] [ -p prec ] [ --comment-delimiter commentdelim ] [ --version | -h | --help ] [ --input-file infile | --input-string instring ] [ --line-separator linesep ] [ --output-file outfile ]

DESCRIPTION
Convert geodetic coordinates to either geocentric or local cartesian coordinates. Geocentric coordinates have the origin at the center of the earth, with the z axis going thru the north pole, and the x axis thru latitude = 0, longitude = 0. By default, the conversion is to geocentric coordinates. Specifying -l lat0 lon0 h0 causes a local coordinate system to be used with the origin at latitude = lat0, longitude = lon0, height = h0, z normal to the ellipsoid and y due north.

Geodetic coordinates are provided on standard input as a set of lines containing (blank separated) latitude, longitude (decimal degrees or degrees, minutes and seconds), and height above the ellipsoid (meters); for details on the allowed formats for latitude and longitude, see the "GEOGRAPHIC COORDINATES" section of GeoConvert(1). For each set of geodetic coordinates, the corresponding cartesian coordinates x, y, z (meters) are printed on standard output.

OPTIONS

-r  perform the reverse projection. x, y, z are given on standard input and each line of standard output gives latitude, longitude, height. In general there are multiple solutions and the result which minimizes the absolute value of height is returned, i.e., (latitude, longitude) corresponds to the closest point on the ellipsoid.

-l lat0 lon0 h0
    specifies conversions to and from a local cartesian coordinate systems with origin lat0 lon0 h0, instead of a geocentric coordinate system. The -w flag can be used to swap the default order of the 2 geographic coordinates, provided that it appears before -l.

-e a f
    specify the ellipsoid via the equatorial radius, a and the flattening, f. Setting f = 0 results in a sphere. Specify f < 0 for a prolate ellipsoid. A simple fraction, e.g., 1/297, is allowed for f. By default, the WGS84 ellipsoid is used, a = 6378137 m, f = 1/298.257223563.

-w  toggle the longitude first flag (it starts off); if the flag is on, then on input and output, longitude precedes latitude (except that, on input, this can be overridden by a hemisphere designator, N, S, E, W).

-p prec
    set the output precision to prec (default 6). prec is the number of digits after the decimal point for geocentric and local cartesian coordinates and for the height (in meters). For latitudes and longitudes (in degrees), the number of digits after the decimal point is prec + 5.

--comment-delimiter commentdelim
    set the comment delimiter to commentdelim (e.g., "#" or "//"). If set, the input lines will be scanned for this delimiter and, if found, the delimiter and the rest of the line will be removed prior to processing and subsequently appended to the output line (separated by a space).

--version
    print version and exit.

-h  print usage and exit.

--help
    print full documentation and exit.

--input-file infile
    read input from the file infile instead of from standard input; a file name of "-" stands for standard input.

--input-string instring
    read input from the string instring instead of from standard input. All occurrences of the line separator character (default is a semicolon) in instring are converted to newlines before the reading begins.

--line-separator linesep
    set the line separator character to linesep. By default this is a semicolon.

--output-file outfile
    write output to the file outfile instead of to standard output; a file name of "-" stands for standard output.

EXAMPLES
   echo 33.3 44.4 6000 | CartConvert
   => 3816209.60 3737108.55 3485109.57
   echo 33.3 44.4 6000 | CartConvert -l 33 44 20
   => 37288.97 33374.29 5783.64
   echo 30000 30000 0 | CartConvert -r
   => 6.483 45 -6335709.73

ERRORS
An illegal line of input will print an error message to standard output beginning with "ERROR:" and causes CartConvert to return an exit code of 1. However, an error does not cause CartConvert to terminate; following lines will be converted.

SEE ALSO
The algorithm for converting geocentric to geodetic coordinates is given in Appendix B of C. F. F. Karney, Geodesics on an ellipsoid of revolution, Feb. 2011; preprint <https://arxiv.org/abs/1102.1215>.

AUTHOR
CartConvert was written by Charles Karney.

HISTORY
CartConvert was added to GeographicLib, <https://geographiclib.sourceforge.io>, in 2009-02. Prior to 2009-03 it was called ECEFConvert.